from Wallet import Wallet
from Warehouse import Warehouse
from Investor import Investor
import numpy as np
import matplotlib
import matplotlib.pyplot as plt

''' It executes a simulation with an investor and a wallet '''
class Simulator:
	def __init__(self, investor):
		self.investor = investor

	def run(self):
		self.investor.wallet.restart()
		self.usdSeries = np.array([])
		while self.investor.wallet.hasNext():
			self.investor.live()
			usd = self.investor.wallet.getTotalUsd()
			# print(usd)
			self.usdSeries = np.append(self.usdSeries, usd)
			self.investor.wallet.next()

	def plot(self):
		fig, ax = plt.subplots()
		ax.plot_date(self.investor.wallet.wh.times, self.usdSeries, fmt="-", \
			label='Investor Capital')
		ax.plot_date(self.investor.wallet.wh.times, self.investor.wallet.wh.prices, \
			fmt="-", label='Bitcoin Value')
		ax.plot(self.wallet.wh.times, self.wallet.wh.movMeans, label="Moving Mean")
		ax.set(xlabel='Date (yyyy-mm-dd)', ylabel='Capital or price (USD)')
		ax.legend()
		plt.show()
