import pandas as pd
import matplotlib
import matplotlib.pyplot as plt
import numpy as np
from datetime import datetime
import math

#### Script for showing a figure of moving mean

# Constants
filename="C:/Users/Iván García-Magariño/Desktop/AuxBigData/BitCoin/bitcoin-historical-data/coinbaseUSD_1-min_data_2014-12-01_to_2019-01-09.csv"
init = 15000
end =  0
windowSize = 1000

# filename= "data.csv"
# nValues = 30
# windowSize = 4


# It calculates a mobile average of a np series in the last point
# for a certain window size
def mobileAvg(series):
	sum=0
	count = 0
	for i in range(max(0, len(series)-windowSize),len(series)):
		sum=sum+series[i]
		count = count+1
	return sum/count


def plotMovMean():
	df = pd.read_csv(filename)
	t = np.array([])
	prices = np.array([])
	mobAvg = np.array([])
	for i in range(max(0, len(df.values)-init), max(0, len(df.values)-end)):
		price = df.at[i, 'Open']
		if not math.isnan(price):
			t=np.append(t, datetime.fromtimestamp(df.at[i, 'Timestamp']))	
			prices = np.append(prices, price)	
			mobAvg = np.append(mobAvg, mobileAvg(prices))	
	fig, ax = plt.subplots()
	ax.plot_date(t, prices, fmt="-", label='Bitcoin Value')
	ax.plot(t, mobAvg, label="Moving Mean")
	ax.set(xlabel='Date (yyyy-mm-dd)', ylabel='Bitcoin Price (USD)')
	ax.legend()
	plt.show()

# ------------- MAIN ---------------

plotMovMean()
