import pandas as pd
import matplotlib
import matplotlib.pyplot as plt
import numpy as np
from datetime import datetime
import math
import time
from matplotlib.dates import (YEARLY, DateFormatter,
                              rrulewrapper, RRuleLocator, drange)

#### Script for showing a figure of moving mean

# Constants
#filename="C:/Users/Iván García-Magariño/trab/NoSinc/BigDatasets/HourlyEnergy/AEP_hourly.csv"
filename="data.csv"

# First Figure
init = 150    
end =  50
windowSize = 24

# Second Figure with 
#init = 400    
#end =  0
#windowSize = 24

# filename= "data.csv"
# nValues = 30
# windowSize = 4


# It calculates a mobile average of a np series in the last point
# for a certain window size
def mobileAvg(series):
	sum=0
	count = 0
	for i in range(max(0, len(series)-windowSize),len(series)):
		sum=sum+series[i]
		count = count+1
	return sum/count


def plotMovMean():
	df = pd.read_csv(filename)
	t = np.array([])
	prices = np.array([])
	mobAvg = np.array([])
	for i in range(max(0, len(df.values)-init), max(0, len(df.values)-end)):
		price = df.at[i, 'AEP_MW']
		if not math.isnan(price):
			# t=np.append(t, datetime.fromtimestamp(df.at[i, 'Timestamp']))	
			t=np.append(t, datetime.strptime(df.at[i, 'Datetime'],'%Y-%m-%d %H:%M:%S'))	
			prices = np.append(prices, price)	
			mobAvg = np.append(mobAvg, mobileAvg(prices))	
	fig, ax = plt.subplots()
	ax.plot_date(t, prices, fmt="-", label='Hourly Energy Consumption', xdate=True)
	ax.plot(t, mobAvg, label="Moving Mean")
	ax.set(xlabel='Date (dd-mm hh)', ylabel='IoT sensor data about energy (Megawatt)') # First Figure
	#ax.set(xlabel='Date (yyyy-mm-dd)', ylabel='Energy Consumption (Megawatt)') # Second Figure
	ax.xaxis.set_tick_params(rotation=30, labelsize=10)
	ax.legend()
	plt.show()

# ------------- MAIN ---------------

plotMovMean()
